/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.io
{
	/// <summary>Debug IoAdapter syncing to drive after every write call.</summary>
	/// <remarks>Debug IoAdapter syncing to drive after every write call.</remarks>
	public class SafeSyncIoAdapter : com.db4o.io.VanillaIoAdapter
	{
		public SafeSyncIoAdapter(com.db4o.io.IoAdapter delegateAdapter) : base(delegateAdapter
			)
		{
		}

		private SafeSyncIoAdapter(com.db4o.io.IoAdapter delegateAdapter, string path, bool
			 lockFile, long initialLength) : base(delegateAdapter.open(path, lockFile, initialLength
			))
		{
		}

		public override com.db4o.io.IoAdapter open(string path, bool lockFile, long initialLength
			)
		{
			return new com.db4o.io.SafeSyncIoAdapter(_delegate, path, lockFile, initialLength
				);
		}

		public override void write(byte[] buffer, int length)
		{
			base.write(buffer, length);
			sync();
		}
	}
}
